=== modified file 'bzrlib/testament.py'
--- bzrlib/testament.py	2005-12-25 00:38:48 +0000
+++ bzrlib/testament.py	2006-02-12 22:40:24 +0000
@@ -114,8 +114,7 @@
         hashed in that encoding.
         """
         r = []
-        def a(s):
-            r.append(s)
+        a = r.append
         a('bazaar-ng testament version 1\n')
         a('revision-id: %s\n' % self.revision_id)
         a('committer: %s\n' % self.committer)
@@ -137,7 +136,7 @@
             for l in r:
                 assert isinstance(l, basestring), \
                     '%r of type %s is not a plain string' % (l, type(l))
-        return r
+        return [line.encode('utf-8') for line in r]
 
     def _escape_path(self, path):
         assert not contains_linebreaks(path)

=== modified file 'bzrlib/tests/test_testament.py'
--- bzrlib/tests/test_testament.py	2006-01-27 08:09:59 +0000
+++ bzrlib/tests/test_testament.py	2006-02-16 16:49:08 +0000
@@ -118,6 +118,17 @@
         t = Testament.from_revision(self.b.repository, 'test@user-3')
         self.assertEqualDiff(t.as_text(), REV_PROPS_TESTAMENT)
 
+    def test_testament_unicode_commit_message(self):
+        self.b.working_tree().commit(
+            message=u'non-ascii commit \N{COPYRIGHT SIGN} me',
+            timestamp=1129025493,
+            timezone=36000,
+            rev_id='test@user-3',
+            committer='test@user')
+        t = Testament.from_revision(self.b.repository, 'test@user-3')
+        self.assertEqualDiff(
+            t.as_text(), SAMPLE_UNICODE_TESTAMENT.encode('utf-8'))
+
     def test___init__(self):
         revision = self.b.repository.get_revision('test@user-2')
         inventory = self.b.repository.get_inventory('test@user-2')
@@ -220,3 +231,23 @@
   branch-nick:
     test branch
 """
+
+
+SAMPLE_UNICODE_TESTAMENT = u"""\
+bazaar-ng testament version 1
+revision-id: test@user-3
+committer: test@user
+timestamp: 1129025493
+timezone: 36000
+parents:
+  test@user-2
+message:
+  non-ascii commit \N{COPYRIGHT SIGN} me
+inventory:
+  file hello hello-id 34dd0ac19a24bf80c4d33b5c8960196e8d8d1f73
+  directory src src-id
+  file src/foo.c foo.c-id a2a049c20f908ae31b231d98779eb63c66448f24
+properties:
+  branch-nick:
+    test branch
+"""

